﻿Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load


        '初期化
        DbGridEx1.Init(Me)

        '表示倍率
        DbGridEx1.Magnification = 1.25

        '表示位置
        DbGridEx1.Left = 40
        DbGridEx1.Top = 32

        '表示サイズ
        DbGridEx1.Width = 580
        DbGridEx1.Height = 400

        '行数指定
        DbGridEx1.Grid.LineMax = 2

        '列の設定
        DbGridEx1.Grid.Column.Add("gakunen", "学年", DbGridEx.ColumnType.DropDownList, 70, 10)
        DbGridEx1.Grid.Column.EditMode("gakunen", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("gakunen", DbGridEx.IMEtype.IMEoff)
        DbGridEx1.Grid.Column.CellPosition("gakunen", DbGridEx.DispPosition.MidLeft)

        DbGridEx1.Grid.Column.Add("kyouka", "教科", DbGridEx.ColumnType.DropDownList, 80, 10)
        DbGridEx1.Grid.Column.EditMode("kyouka", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("kyouka", DbGridEx.IMEtype.IMEoff)
        DbGridEx1.Grid.Column.CellPosition("kyouka", DbGridEx.DispPosition.MidLeft)

        DbGridEx1.Grid.Column.Add("kamoku", "科目", DbGridEx.ColumnType.StringType, 150, 20)
        DbGridEx1.Grid.Column.EditMode("kamoku", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("kamoku", DbGridEx.IMEtype.Hiragana)
        DbGridEx1.Grid.Column.CellPosition("kamoku", DbGridEx.DispPosition.MidLeft)

        DbGridEx1.Grid.Column.Add("tani", "単位", DbGridEx.ColumnType.LongType, 60, 10)
        DbGridEx1.Grid.Column.EditMode("tani", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("tani", DbGridEx.IMEtype.Numeric)
        DbGridEx1.Grid.Column.CellPosition("tani", DbGridEx.DispPosition.MidCenter)
        DbGridEx1.Grid.Column.Line("tani", 1, 1)
        DbGridEx1.Grid.Header.Line("tani", 1, 1)


        DbGridEx1.Grid.Column.Add("sentaku", "選択", DbGridEx.ColumnType.CheckBoxType, 60, 10)
        DbGridEx1.Grid.Column.EditMode("sentaku", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("sentaku", DbGridEx.IMEtype.Numeric)
        DbGridEx1.Grid.Column.CellPosition("sentaku", DbGridEx.DispPosition.MidCenter)
        DbGridEx1.Grid.Column.Line("sentaku", 1, 1)
        DbGridEx1.Grid.Header.Line("sentaku", 1, 1)

        DbGridEx1.Grid.Column.Add("memo", "備考", DbGridEx.ColumnType.StringType, 180, 10)
        DbGridEx1.Grid.Column.EditMode("memo", DbGridEx.CellEdit.EditMode)
        DbGridEx1.Grid.Column.IME("memo", DbGridEx.IMEtype.Hiragana)
        DbGridEx1.Grid.Column.CellPosition("memo", DbGridEx.DispPosition.MidLeft)
        DbGridEx1.Grid.Column.Line("memo", 1, 1)
        DbGridEx1.Grid.Header.Line("memo", 1, 1)



        'チェックボックスの設定
        DbGridEx1.Grid.Column.CheckOn("sentaku", 1, 0)

        'グリッドを作成
        DbGridEx1.CreateGrid()

        '並び替え条件の設定
        DbGridEx1.Grid.Sort = "gakunen , kyouka"

        'コンボの選択肢を設定
        DbGridEx1.Grid.Column.Combo.ItemClear("gakunen")
        DbGridEx1.Grid.Column.Combo.ItemADD("gakunen", 1, "１年")
        DbGridEx1.Grid.Column.Combo.ItemADD("gakunen", 2, "２年")
        DbGridEx1.Grid.Column.Combo.ItemADD("gakunen", 3, "３年")


        DbGridEx1.Grid.Column.Combo.ItemClear("kyouka")
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 1, "国語", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 2, "数学", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 3, "理科", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 4, "社会", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 5, "英語", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 6, "体育", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 7, "芸術", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 8, "家庭科", 1)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 9, "情報処理", 1)

        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 1, "国語", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 2, "数学", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 3, "理科", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 4, "社会", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 5, "外国語", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 6, "体育", 2)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 7, "専門２年", 2)

        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 1, "国語", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 2, "数学", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 3, "理科", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 4, "社会", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 5, "外国語", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 6, "体育", 3)
        DbGridEx1.Grid.Column.Combo.ItemADD("kyouka", 7, "専門３年", 3)

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        'データ登録
        DbGridEx1.Record.Clear()
        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 1)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "現代文")
        DbGridEx1.Record.AddData("tani", 5)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 2)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "数学Ⅰ")
        DbGridEx1.Record.AddData("tani", 4)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 3)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "化学")
        DbGridEx1.Record.AddData("tani", 3)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 4)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "地理")
        DbGridEx1.Record.AddData("tani", 3)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 5)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "英語Ⅰ")
        DbGridEx1.Record.AddData("tani", 4)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 6)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "体育")
        DbGridEx1.Record.AddData("tani", 3)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 7)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "書道")
        DbGridEx1.Record.AddData("tani", 2)
        DbGridEx1.Record.AddData("sentaku", 1)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 7)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "音楽")
        DbGridEx1.Record.AddData("tani", 2)
        DbGridEx1.Record.AddData("sentaku", 1)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 7)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "美術")
        DbGridEx1.Record.AddData("tani", 2)
        DbGridEx1.Record.AddData("sentaku", 1)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 8)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "基礎家庭科")
        DbGridEx1.Record.AddData("tani", 2)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)

        DbGridEx1.Record.AddNew()
        DbGridEx1.Record.AddData("gakunen", 1)
        DbGridEx1.Record.AddFilter("gakunen", 0)
        DbGridEx1.Record.AddData("kyouka", 9)
        DbGridEx1.Record.AddFilter("kyouka", 1)     '１年のフィルター
        DbGridEx1.Record.AddData("kamoku", "基礎コンピューター")
        DbGridEx1.Record.AddData("tani", 3)
        DbGridEx1.Record.AddData("sentaku", 0)
        DbGridEx1.Record.AddUpdate(DbGridEx.LineEditMode.NewLine)


    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        'データ読み出し

        If DbGridEx1.Record.Count = 0 Then
            Exit Sub
        End If

        Debug.Print("レコード行数 =" & Str(DbGridEx1.Record.Count))

        DbGridEx1.Record.StatusFilter(DbGridEx.LineStatus.AllLine)
        DbGridEx1.Record.MoveFirst()
        Do Until DbGridEx1.Record.EOF
            '学年
            Debug.Print("学年 =" & Str(DbGridEx1.Record.CurrentValue("gakunen")))

            '教科
            Debug.Print("教科 =" & Str(DbGridEx1.Record.CurrentValue("kyouka")))

            '科目
            Debug.Print("科目 =" & DbGridEx1.Record.CurrentValue("kamoku"))

            '単位
            Debug.Print("単位 =" & Str(DbGridEx1.Record.CurrentValue("tani")))

            '選択
            Debug.Print("選択 =" & Str(DbGridEx1.Record.CurrentValue("sentaku")))

            DbGridEx1.Record.MoveNext()
        Loop

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        'データ変更
        DbGridEx1.Record.StatusFilter(DbGridEx.LineStatus.AllLine)
        DbGridEx1.Record.MoveFirst()
        Do Until DbGridEx1.Record.EOF
            If DbGridEx1.Status.CurrentChanged Then
                Debug.Print("Changed")
            Else
                Debug.Print("No Chang")
            End If

            DbGridEx1.Record.MoveNext()
        Loop
    End Sub

End Class
